VTK: vtkImageActorPointPlacer Class Reference

| VTK 9.3.1

Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkImageActorPointPlacer Class Reference

Converts 2D display positions to world positions such that they lie on an ImageActor. More...

`#include <vtkImageActorPointPlacer.h>`

Inheritance diagram for vtkImageActorPointPlacer:
[legend]
Collaboration diagram for vtkImageActorPointPlacer:
[legend]

## Public Member Functions
int | ComputeWorldPosition (vtkRenderer *ren, double displayPos[2], double worldPos[3], double worldOrient[9]) override
| Given and renderer and a display position in pixels, find a world position and orientation. More...
int | ComputeWorldPosition (vtkRenderer *ren, double displayPos[2], double refWorldPos[2], double worldPos[3], double worldOrient[9]) override
| This method is identical to the one above since the reference position is ignored by the bounded plane point placer. More...
int | ValidateWorldPosition (double worldPos[3]) override
| This method validates a world position by checking to see if the world position is valid according to the constraints of the internal placer (essentially - is this world position on the image?) More...
int | ValidateWorldPosition (double worldPos[3], double worldOrient[9]) override
| This method is identical to the one above since the bounded plane point placer ignores orientation. More...
int | UpdateWorldPosition (vtkRenderer *ren, double worldPos[3], double worldOrient[9]) override
| Update the world position and orientation according the the current constraints of the placer. More...
int | UpdateInternalState () override
| A method for configuring the internal placer according to the constraints of the image actor. More...
void | SetWorldTolerance (double tol) override
| Set the world tolerance. More...
void | SetImageActor (vtkImageActor *)
| Set / get the reference vtkImageActor used to place the points. More...
virtual vtkImageActor * | GetImageActor ()
| Set / get the reference vtkImageActor used to place the points. More...
virtual void | SetBounds (double, double, double, double, double, double)
| Optionally, you may set bounds to restrict the placement of the points. More...
virtual void | SetBounds (double[6])
| Optionally, you may set bounds to restrict the placement of the points. More...
virtual double * | GetBounds ()
| Optionally, you may set bounds to restrict the placement of the points. More...
virtual void | GetBounds (double &, double &, double &, double &, double &, double &)
| Optionally, you may set bounds to restrict the placement of the points. More...
virtual void | GetBounds (double[6])
| Optionally, you may set bounds to restrict the placement of the points. More...
Public Member Functions inherited from vtkPointPlacer
virtual int | ComputeWorldPosition (vtkRenderer *ren, double displayPos[2], double refWorldPos[3], double worldPos[3], double worldOrient[9])
| Given a renderer, a display position, and a reference world position, compute the new world position and orientation of this point. More...
virtual int | ValidateDisplayPosition (vtkRenderer *, double displayPos[2])
| Given a display position, check the validity of this position. More...
virtual int | UpdateNodeWorldPosition (double worldPos[3], vtkIdType nodePointId)
| Give the placer a chance to update the node information, if any. More...
virtual void | SetPixelTolerance (int)
| Set/get the tolerance used when performing computations in display coordinates. More...
virtual int | GetPixelTolerance ()
| Set/get the tolerance used when performing computations in display coordinates. More...
virtual double | GetWorldTolerance ()
| Set/get the tolerance used when performing computations in world coordinates. More...
vtkPointPlacer * | NewInstance () const
| Standard methods for instances of this class. More...
void | PrintSelf (ostream &os, vtkIndent indent) override
| Standard methods for instances of this class. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkImageActorPointPlacer * | New ()
| Instantiate this class. More...
Static Public Member Functions inherited from vtkPointPlacer
static vtkPointPlacer * | New ()
| Instantiate this class. More...
static vtkTypeBool | IsTypeOf (const char *type)
| Standard methods for instances of this class. More...
static vtkPointPlacer * | SafeDownCast (vtkObjectBase *o)
| Standard methods for instances of this class. More...
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
| vtkImageActorPointPlacer ()
| ~vtkImageActorPointPlacer () override
Protected Member Functions inherited from vtkPointPlacer
| vtkPointPlacer ()
| ~vtkPointPlacer () override
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
vtkImageActor * | ImageActor
vtkBoundedPlanePointPlacer * | Placer
double | SavedBounds [6]
double | Bounds [6]
Protected Attributes inherited from vtkPointPlacer
int | PixelTolerance
double | WorldTolerance
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers
typedef vtkPointPlacer | Superclass
| Standard methods for instances of this class. More...
static vtkTypeBool | IsTypeOf (const char *type)
| Standard methods for instances of this class. More...
static vtkImageActorPointPlacer * | SafeDownCast (vtkObjectBase *o)
| Standard methods for instances of this class. More...
virtual vtkTypeBool | IsA (const char *type)
| Standard methods for instances of this class. More...
vtkImageActorPointPlacer * | NewInstance () const
| Standard methods for instances of this class. More...
void | PrintSelf (ostream &os, vtkIndent indent) override
| Standard methods for instances of this class. More...
virtual vtkObjectBase * | NewInstanceInternal () const
| Standard methods for instances of this class. More...

## Additional Inherited Members
Public Types inherited from vtkPointPlacer
typedef vtkObject | Superclass
| Standard methods for instances of this class. More...
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Detailed Description

Converts 2D display positions to world positions such that they lie on an ImageActor.

This PointPlacer is used to constrain the placement of points on the supplied image actor. Additionally, you may set bounds to restrict the placement of the points. The placement of points will then be constrained to lie not only on the ImageActor but also within the bounds specified. If no bounds are specified, they may lie anywhere on the supplied ImageActor.

Tests:
  vtkImageActorPointPlacer (Tests)

Definition at line 28 of file vtkImageActorPointPlacer.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkPointPlacer vtkImageActorPointPlacer::Superclass

Standard methods for instances of this class.

Definition at line 40 of file vtkImageActorPointPlacer.h.

## Constructor & Destructor Documentation

## ◆ vtkImageActorPointPlacer()

vtkImageActorPointPlacer::vtkImageActorPointPlacer | ( |  | ) |
| protected

## ◆ ~vtkImageActorPointPlacer()

vtkImageActorPointPlacer::~vtkImageActorPointPlacer | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ New()

static vtkImageActorPointPlacer* vtkImageActorPointPlacer::New | ( |  | ) |
| static

Instantiate this class.

## ◆ IsTypeOf()

static vtkTypeBool vtkImageActorPointPlacer::IsTypeOf | ( | const char * | type | ) |
| static

Standard methods for instances of this class.

## ◆ IsA()

virtual vtkTypeBool vtkImageActorPointPlacer::IsA | ( | const char * | type | ) |
| virtual

Standard methods for instances of this class.

Reimplemented from vtkPointPlacer.

## ◆ SafeDownCast()

static vtkImageActorPointPlacer* vtkImageActorPointPlacer::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

Standard methods for instances of this class.

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkImageActorPointPlacer::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Standard methods for instances of this class.

Reimplemented from vtkPointPlacer.

## ◆ NewInstance()

vtkImageActorPointPlacer* vtkImageActorPointPlacer::NewInstance | ( |  | ) | const

Standard methods for instances of this class.

## ◆ PrintSelf()

void vtkImageActorPointPlacer::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Standard methods for instances of this class.

Reimplemented from vtkObject.

## ◆ ComputeWorldPosition() [1/2]

int vtkImageActorPointPlacer::ComputeWorldPosition | ( | vtkRenderer * | ren,
|  | double | displayPos[2],
|  | double | worldPos[3],
|  | double | worldOrient[9]
| ) |  |
| overridevirtual

Given and renderer and a display position in pixels, find a world position and orientation.

In this class an internal vtkBoundedPlanePointPlacer is used to compute the world position and orientation. The internal placer is set to use the plane of the image actor and the bounds of the image actor as the constraints for placing points.

Reimplemented from vtkPointPlacer.

## ◆ ComputeWorldPosition() [2/2]

int vtkImageActorPointPlacer::ComputeWorldPosition | ( | vtkRenderer * | ren,
|  | double | displayPos[2],
|  | double | refWorldPos[2],
|  | double | worldPos[3],
|  | double | worldOrient[9]
| ) |  |
| override

This method is identical to the one above since the reference position is ignored by the bounded plane point placer.

## ◆ ValidateWorldPosition() [1/2]

int vtkImageActorPointPlacer::ValidateWorldPosition | ( | double | worldPos[3] | ) |
| overridevirtual

This method validates a world position by checking to see if the world position is valid according to the constraints of the internal placer (essentially - is this world position on the image?)

Reimplemented from vtkPointPlacer.

## ◆ ValidateWorldPosition() [2/2]

int vtkImageActorPointPlacer::ValidateWorldPosition | ( | double | worldPos[3],
|  | double | worldOrient[9]
| ) |  |
| overridevirtual

This method is identical to the one above since the bounded plane point placer ignores orientation.

Reimplemented from vtkPointPlacer.

## ◆ UpdateWorldPosition()

int vtkImageActorPointPlacer::UpdateWorldPosition | ( | vtkRenderer * | ren,
|  | double | worldPos[3],
|  | double | worldOrient[9]
| ) |  |
| overridevirtual

Update the world position and orientation according the the current constraints of the placer.

Will be called by the representation when it notices that this placer has been modified.

Reimplemented from vtkPointPlacer.

## ◆ UpdateInternalState()

int vtkImageActorPointPlacer::UpdateInternalState | ( |  | ) |
| overridevirtual

A method for configuring the internal placer according to the constraints of the image actor.

Called by the representation to give the placer a chance to update itself, which may cause the MTime to change, which would then cause the representation to update all of its points

Reimplemented from vtkPointPlacer.

## ◆ SetImageActor()

void vtkImageActorPointPlacer::SetImageActor | ( | vtkImageActor * |  | ) |

Set / get the reference vtkImageActor used to place the points.

An image actor must be set for this placer to work. An internal bounded plane point placer is created and set to match the bounds of the displayed image.

## ◆ GetImageActor()

virtual vtkImageActor* vtkImageActorPointPlacer::GetImageActor | ( |  | ) |
| virtual

Set / get the reference vtkImageActor used to place the points.

An image actor must be set for this placer to work. An internal bounded plane point placer is created and set to match the bounds of the displayed image.

## ◆ SetBounds() [1/2]

virtual void vtkImageActorPointPlacer::SetBounds | ( | double | ,
|  | double | ,
|  | double | ,
|  | double | ,
|  | double | ,
|  | double |
| ) |  |
| virtual

Optionally, you may set bounds to restrict the placement of the points.

The placement of points will then be constrained to lie not only on the ImageActor but also within the bounds specified. If no bounds are specified, they may lie anywhere on the supplied ImageActor.

## ◆ SetBounds() [2/2]

virtual void vtkImageActorPointPlacer::SetBounds | ( | double | [6] | ) |
| virtual

Optionally, you may set bounds to restrict the placement of the points.

The placement of points will then be constrained to lie not only on the ImageActor but also within the bounds specified. If no bounds are specified, they may lie anywhere on the supplied ImageActor.

## ◆ GetBounds() [1/3]

virtual double* vtkImageActorPointPlacer::GetBounds | ( |  | ) |
| virtual

Optionally, you may set bounds to restrict the placement of the points.

The placement of points will then be constrained to lie not only on the ImageActor but also within the bounds specified. If no bounds are specified, they may lie anywhere on the supplied ImageActor.

## ◆ GetBounds() [2/3]

virtual void vtkImageActorPointPlacer::GetBounds | ( | double & | ,
|  | double & | ,
|  | double & | ,
|  | double & | ,
|  | double & | ,
|  | double & |
| ) |  |
| virtual

Optionally, you may set bounds to restrict the placement of the points.

The placement of points will then be constrained to lie not only on the ImageActor but also within the bounds specified. If no bounds are specified, they may lie anywhere on the supplied ImageActor.

## ◆ GetBounds() [3/3]

virtual void vtkImageActorPointPlacer::GetBounds | ( | double | [6] | ) |
| virtual

Optionally, you may set bounds to restrict the placement of the points.

The placement of points will then be constrained to lie not only on the ImageActor but also within the bounds specified. If no bounds are specified, they may lie anywhere on the supplied ImageActor.

## ◆ SetWorldTolerance()

void vtkImageActorPointPlacer::SetWorldTolerance | ( | double | tol | ) |
| overridevirtual

Set the world tolerance.

This propagates it to the internal BoundedPlanePointPlacer.

Reimplemented from vtkPointPlacer.

## Member Data Documentation

## ◆ ImageActor

vtkImageActor* vtkImageActorPointPlacer::ImageActor
| protected

Definition at line 129 of file vtkImageActorPointPlacer.h.

## ◆ Placer

vtkBoundedPlanePointPlacer* vtkImageActorPointPlacer::Placer
| protected

Definition at line 132 of file vtkImageActorPointPlacer.h.

## ◆ SavedBounds

double vtkImageActorPointPlacer::SavedBounds[6]
| protected

Definition at line 136 of file vtkImageActorPointPlacer.h.

## ◆ Bounds

double vtkImageActorPointPlacer::Bounds[6]
| protected

Definition at line 139 of file vtkImageActorPointPlacer.h.

The documentation for this class was generated from the following file:

- Interaction/Widgets/vtkImageActorPointPlacer.h